﻿using System;
using System.Collections.Generic;
using System.Data;

namespace Wisej_DGVVirtualMode
{
	public class ArtistCache
	{
		private int _pageSize;
		private int _pageCount;
		private Dictionary<int, DataTable> _cache = new Dictionary<int, DataTable>();

		public ArtistCache(int pageSize, int pageCount)
		{
			this._pageSize = pageSize;
			this._pageCount = pageCount;
		}

		public object GetValue(int row, int col)
		{
			lock (this)
			{
				int page = row / this._pageSize;
				var firstPageRow = page * this._pageSize;
				var dataTable = LoadCache(firstPageRow, this._pageSize);
				return dataTable.Rows[row - firstPageRow][col];
			}
		}

		public DataTable LoadCache(int firstPageRow, int count)
		{
			lock (this)
			{
				if (!this._cache.ContainsKey(firstPageRow))
				{
					var dataTable = DB.ReadEmployeeRows(firstPageRow, count);
					this._cache[firstPageRow] = dataTable;

					if (this._cache.Count > this._pageCount)
					{
						int max = -1;
						int key = -1;
						foreach (var entry in this._cache)
						{
							if (Math.Abs(entry.Key - firstPageRow) > max)
							{
								key = entry.Key;
								max = Math.Abs(entry.Key - firstPageRow);
							}
						}
						this._cache.Remove(key);
					}
					return dataTable;
				}
				else{

					return this._cache[firstPageRow];
				}
			}
		}
	}
}
